package be.jeffcheasey88.peeratcode.parser.java.operation;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;

import be.jeffcheasey88.peeratcode.parser.java.JavaElement;
import be.jeffcheasey88.peeratcode.parser.java.Operation;
import be.jeffcheasey88.peeratcode.parser.java.Variable;
import be.jeffcheasey88.peeratcode.parser.java.Operation.OperationContainer;
import be.jeffcheasey88.peeratcode.parser.java.Variable.VariableContainer;

public class OperationBag extends Operation implements VariableContainer, OperationContainer{

	private List<JavaElement> elements;
	
	public OperationBag(){
		this.elements = new ArrayList<>();
	}
	
	@Override
	public void addVariable(Variable variable){
		this.elements.add(variable);
	}
	
	@Override
	public void addOperation(Operation operation){
		this.elements.add(operation);
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder){
		for(JavaElement element : this.elements){
			if(finder.apply(element)) return (E)element;
		}
		return null;
	}

}
